//+------------------------------------------------------------------+
//|                                                  Heiken Ashi.mq4 |
//|                      Copyright c 2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_color3 Blue
#property indicator_color4 Blue
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3

extern ENUM_TIMEFRAMES TimeFrame         =PERIOD_CURRENT;
extern int             EMA_Period        =13;
extern int             MACD_FastPeriod   =12;
extern int             MACD_SlowPeriod   =26;
extern int             MACD_SignalPeriod =9;
extern bool            UseMT4MACD        =false;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

double MACDLineBuffer[];
double MACDSignalLineBuffer[];
double MACDHistogramBuffer[];

//----
int ExtCountedBars=0;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0, ExtMapBuffer1);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, ExtMapBuffer2);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, ExtMapBuffer3);   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, ExtMapBuffer4);   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,MACDSignalLineBuffer);   SetIndexEmptyValue(4,0.0);
   SetIndexBuffer(5,MACDLineBuffer);         SetIndexEmptyValue(5,0.0);
   SetIndexBuffer(6,MACDHistogramBuffer);    SetIndexEmptyValue(6,0.0);
   TimeFrame = MathMax(TimeFrame,_Period);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(MathMax(Bars-counted_bars,2*TimeFrame/_Period),Bars-1);

   double alpha = 2.0 / (MACD_SignalPeriod + 1.0);
   double alpha_1 = 1.0 - alpha;

   for (int pos=limit; pos>=0; pos--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[pos]); 
      double ema0=iMA(NULL,TimeFrame,EMA_Period,0,MODE_EMA,PRICE_CLOSE,y); 
      double ema1=iMA(NULL,TimeFrame,EMA_Period,0,MODE_EMA,PRICE_CLOSE,y+1); 

      if(UseMT4MACD)
      {
        double main0=iMACD(NULL, TimeFrame, MACD_FastPeriod, MACD_SlowPeriod, MACD_SignalPeriod, PRICE_CLOSE,0,y); 
        double main1=iMACD(NULL, TimeFrame, MACD_FastPeriod, MACD_SlowPeriod, MACD_SignalPeriod, PRICE_CLOSE,0,y+1); 

        double signal0=iMACD(NULL, TimeFrame, MACD_FastPeriod, MACD_SlowPeriod, MACD_SignalPeriod, PRICE_CLOSE,1,y); 
        double signal1=iMACD(NULL, TimeFrame, MACD_FastPeriod, MACD_SlowPeriod, MACD_SignalPeriod, PRICE_CLOSE,1,y+1); 
        
        double main  = main0; 
        double macd0 = main0-signal0;
        double macd1 = main1-signal1;
      } else
      {
        MACDLineBuffer[y] = iMA(NULL,TimeFrame,MACD_FastPeriod,0,MODE_EMA,PRICE_CLOSE,y)- 
                            iMA(NULL,TimeFrame,MACD_SlowPeriod,0,MODE_EMA,PRICE_CLOSE,y);
        MACDSignalLineBuffer[y]=(alpha*MACDLineBuffer[y]) + (alpha_1*MACDSignalLineBuffer[y+1]);
        MACDHistogramBuffer[y]=MACDLineBuffer[y]-MACDSignalLineBuffer[y];
        
        main=MACDLineBuffer[y]; 
        macd0=MACDHistogramBuffer[y];
        macd1=MACDHistogramBuffer[y+1];
      }
      double aOpen=Open[pos];
      double aClose=Close[pos];
      if(ema0<ema1 && macd0<macd1) //both down - Red
      {
        if(aOpen<aClose)
        {
          ExtMapBuffer1[pos]=aClose;
          ExtMapBuffer2[pos]=aOpen;
          ExtMapBuffer3[pos]=EMPTY_VALUE;
          ExtMapBuffer4[pos]=EMPTY_VALUE;
        } else
        {
          ExtMapBuffer1[pos]=aOpen;
          ExtMapBuffer2[pos]=aClose;
          ExtMapBuffer3[pos]=EMPTY_VALUE;
          ExtMapBuffer4[pos]=EMPTY_VALUE;
        }
      } else
      if(ema0>ema1 && macd0>macd1) //both up - Lime
      {
        if(aOpen<aClose)
        {
          ExtMapBuffer1[pos]=aOpen;
          ExtMapBuffer2[pos]=aClose;
          ExtMapBuffer3[pos]=EMPTY_VALUE;
          ExtMapBuffer4[pos]=EMPTY_VALUE;
        } else
        {
          ExtMapBuffer1[pos]=aClose;
          ExtMapBuffer2[pos]=aOpen;
          ExtMapBuffer3[pos]=EMPTY_VALUE;
          ExtMapBuffer4[pos]=EMPTY_VALUE;
        }
      } else  //otherwise - Blue
      {
          ExtMapBuffer3[pos]=aOpen;
          ExtMapBuffer4[pos]=aClose;
          ExtMapBuffer1[pos]=EMPTY_VALUE;
          ExtMapBuffer2[pos]=EMPTY_VALUE;
      }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+